; Programa: Funciones para testear agentes de juego a los bloques
;
; Asignatura: Introduccin a la Inteligencia Artificial
;             ETSII - ULL
; Prctica: 6a (sistemas de produccin)
; Profesor: Patricio Garca (patricio@csi.ull.es)
; Fecha:    30/5/2004
; Comentarios:
;
;           Cdigos necesarios para testear los agentes inteligente
;           para jugar a los bloques. Se basa en la funcin TEST, 
;           ver el correspondiente help.
;
;           Para poder utilizarlo directamente es necesario cambiar 
;           los valores de las variables siguientes:
;             AGENTES: Colocar lista de funciones de agentes a testear
;             VARIABLE-GENERADOS: Nombre de la variable de nodos generados
;             VARIABLE-EXPANDIDOS: Nombre de la variable de nodos expandidos
;
;           Combiene tambin colocar a NULL la funcin de impresin 
;           de estados y no olvidar compilar todos los cdigos 
;           (ver (HELP 'COMPILE-FILE)) para acelerar las ejecuciones.
;
; Ejemplo de llamada a pruebas (ejecutar manualmente)
; ---------------------------------------------------
; (test fichs agentes repeticiones)
;
;
; Ejemplo de llamada a pruebas que deja rastro en /scratch/bumper/hof.txt
; -----------------------------------------------------------------------
; (test fichs agentes repeticiones :hof t)
;

; Se cargan las librerias
(load "bloques") 
(load "shell") 
(load "q_search")
(load "a_star")

; Poner a continuacin cdigo necesario para cargar tus agentes
; -------------------------------------------------------------
; Ojo, no olvidar compilar todo antes (compile-file "<fich-agente.lsp>")
; ----------------------------------------------------------------------
(load "agentes-intl") 

; Se coloca la funcin de impresin a null (revisa tu cdigo)
; -----------------------------------------------------------
(setf func-vis-estado1 #'null)

; Poner a continuacin la lista de las funciones de tu agente
; -----------------------------------------------------------
(defvar agentes '(
		  a-h2 
		  a-h1 
		  bpm-h2 
		  bpm-h1 
		  bp 
		  ba))

; Nombre de las variables globales de tu cdigo que guarda
; el nmero de nodos generados en la ltima ejecucin
; --------------------------------------------------------
(defvar variable-generados 'generados)

; Nombre de las variables globales de tu cdigo que guarda
; el nmero de nodos expandidos en la ltima ejecucin
; --------------------------------------------------------
(defvar variable-expandidos 'expandidos)


; Lista de problemas a testear
(defvar fichs '("/scratch/bloques/test1.blq" "/scratch/bloques/test2.blq"))

; Nmero de repeticiones por problema y tipo sol.
(defvar repeticiones 1)


; Funcin que lanza las pruebas
(defun test (fichs agentes repeticiones &key hof)
  " - Funcin: TEST (FICHS AGENTES REPETICIONES &KEY HOF)

Inicia la ejecucin de una batera de problemas sobre una lista de agentes e imprime por la salida estandar los resultados de dichas ejecuciones. FICHS es la lista de prametros :fich a probar (ver INIC-BLOQ). AGENTES es la lista de las funciones que implementan los agentes a probar. REPETICIONES es el nmero de veces que se ejecuta cada problema, parmetro :num de INIC-BLOQ. HOF equivale al parmetro :hof, para dejar rastro en el fichero /scratch/bloques/hof.txt.
Devuelve T si todo va bien, imprimiendo por la salida estandar los resultadosde las ejecuciones. Si se desean recoger a un fichero se puede utilizar el comando DRIBBLE (ver (HELP 'DRIBBLE))."
  (let (res)
    (dolist (agente agentes t)
      (dolist (fich fichs t)
	(setf res
	      (inic-bloq agente :fich fich :num repeticiones :hof hof))
	(format t "Agente: ~S  Fich: ~S Mov/par: ~D  Tim/par: ~,2F  Num: ~D  Generados/par: ~D  Expandidos/par: ~D~%"
		agente
		fich
		(/ (second res) (first res))
		(float (/ (third res) (first res)))
		(first res)
		(eval generados) 
		(eval expandidos))))))



; Ejemplo de llamada a pruebas (ejecutar manualmente)
; ---------------------------------------------------
#|
(test fichs agentes repeticiones)
|#

; Ejemplo de llamada a pruebas que deja rastro en /scratch/bloques/hof.txt
; ------------------------------------------------------------------------
#|
(test fichs agentes repeticiones :hof t)
|#



